<template>
    <div class="container-fluid auth-form">
        <div class="d-flex justify-content-center login">
            <div class="card register-card">
                <div class="card-header text-white">
                    <h3>Sign Up</h3>
                </div>
                <div class="card-body">
                    <el-form :model="registerForm" status-icon :rules="rules" ref="registerForm">
                        <el-form-item prop="username">
                            <el-input type="text" v-model="registerForm.username" autocomplete="off" placeholder="username">
                                <template slot="prepend"><i class="fas fa-user"></i></template>
                            </el-input>
                        </el-form-item>
                        <el-form-item prop="email">
                            <el-input type="email" v-model="registerForm.email" autocomplete="off" placeholder="user@example.com">
                                <template slot="prepend"><i class="fas fa-envelope"></i></template>
                            </el-input>
                        </el-form-item>
                        <el-form-item prop="password">
                            <el-input type="password" v-model="registerForm.password" autocomplete="off" placeholder="Password">
                                <template slot="prepend"><i class="fas fa-key"></i></template>
                            </el-input>
                        </el-form-item>
                        <el-form-item prop="checkPass">
                            <el-input type="password" v-model="registerForm.checkPass" autocomplete="off" placeholder="Confirm">
                                <template slot="prepend"><i class="fas fa-key"></i></template>
                            </el-input>
                        </el-form-item>
                        <el-form-item prop="user_type">
                            <el-radio-group v-model="registerForm.user_type">
                                <el-radio label="student" border>Student</el-radio>
                                <el-radio label="employer" border>Employer</el-radio>
                            </el-radio-group>
                        </el-form-item>
                        <el-form-item class="mb-0">
                            <button class="btn float-right login_btn" @click="register('registerForm')">Register</button>
                        </el-form-item>
                    </el-form>
                </div>
                <div class="card-footer">
                    <div class="d-flex justify-content-center links">
                        Do you have an account?
                        <router-link :to="{ path : 'login'}">Sign In</router-link>
                    </div>
                    <div class="d-flex justify-content-center">
                        <a href="#">Forgot your password?</a>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<style>
    .el-input-group__prepend {
        background: #42b883;
        border: none;
    }
    .el-input-group__prepend i {
        color: #fff;
    }

    .el-radio {
        color: #fff;
    }
    .el-radio--medium.is-bordered .el-radio__label {
        font-size: 16px;
        font-weight: bold;
    }
    .el-radio.is-bordered.is-checked {
        border-color: #42b883; 
    }
    .el-radio__input.is-checked .el-radio__inner {
        border-color: #42b883;
        background: #42b883;
    }
    .el-radio__input.is-checked+.el-radio__label {
        color: #42b883;
    }
</style>

<script>
    export default {
        data(){
            var validatePass = (rule, value, callback) => {
                if (value === '') {
                  callback(new Error('Please input the password'));
                } else {
                  if (this.registerForm.checkPass !== '') {
                    this.$refs.registerForm.validateField('checkPass');
                  }
                  callback();
                }
            };
            var validatePass2 = (rule, value, callback) => {
                if (value === '') {
                  callback(new Error('Please input the password again'));
                } else if (value !== this.registerForm.password) {
                  callback(new Error('Two inputs don\'t match!'));
                } else {
                  callback();
                }
            };
            return {
                registerForm: {
                    username: '',
                    email: '',
                    password: '',
                    checkPass: '',
                    user_type: '',
                },
                rules: {
                    username: [
                        { required: true, message: 'Please input user name', trigger: 'blur' }
                    ],
                    email: [
                        { required: true, message: 'Please input email address', trigger: ['blur', 'change'] },
                        { type: 'email', message: 'Please input correct email address', trigger: ['blur', 'change'] }
                    ],
                    password: [
                        { validator: validatePass, trigger: ['blur', 'change'] },
                        { min: 8, message: 'Length should be at least 8', trigger: ['blur', 'change'] }
                    ],
                    checkPass: [
                        { validator: validatePass2, trigger: ['blur', 'change'] }
                    ],
                    user_type: [
                        { required: true, message: 'Please select one user type from above', trigger: 'change' }
                    ],
                },
            }
        },
        methods: {
            register(formName){
                this.$refs[formName].validate((valid) => {
                    if (valid) {
                        this.$auth.register({
                            data: {
                                username: this.registerForm.username,
                                email: this.registerForm.email,
                                password: this.registerForm.password,
                                user_type: this.registerForm.user_type
                            },
                            success: function () {
                                this.$message({
                                    type: 'success',
                                    message: 'Success',
                                });
                                this.$router.push( '/' );
                            },
                            error: function (resp) {
                                this.registerForm.error = true;
                                this.registerForm.errors = resp.response.data.errors;
                                this.$message({
                                    type: 'error',
                                    message: resp.response.data.errors.email[0],
                                });
                                this.$refs[formName].resetFields();
                            },
                            autoLogin: true,
                            fetchUser: true,
                            redirect: '/',
                        })
                    } else {
                        this.$message({
                            type: 'warning',
                            message: 'Please check and input correct fields!',
                        });
                        return false;
                    }
                });
            }
        }
    }
</script>

